# Summary

* [优质书籍分享]()
  * [产品类](book/product.md)

* [优质技术文章合集]()
  * [分析调研类](misc/learning.md)
  * [源码解读类](misc/sourcecode.md)
  * [优化实践类](misc/optimized.md)

* [整体介绍]()
  * [Druid概述](README.md)
  * [官方原版英文文档](https://druid.apache.org/docs/latest/design/)

* [新手入门]()
  * [快速开始](GettingStarted/chapter-2.md)
  * [Docker](tutorials/docker.md)
  * [单服务器部署](GettingStarted/chapter-3.md)
  * [集群部署](GettingStarted/chapter-4.md)

* [使用指导]()
  * [加载本地文件](tutorials/tutorial-batch.md)
  * [从Kafka加载数据](tutorials/chapter-2.md)
  * [从Hadoop加载数据](tutorials/chapter-3.md)
  * [查询数据](tutorials/chapter-4.md)
  * [Rollup操作](tutorials/chapter-5.md)
  * [配置数据保留规则](tutorials/chapter-6.md)
  * [数据更新](tutorials/chapter-7.md)
  * [合并段文件](tutorials/chapter-8.md)
  * [删除数据](tutorials/chapter-9.md)
  * [摄入配置规范](tutorials/chapter-10.md)
  * [转换输入数据](tutorials/chapter-11.md)
  * [Kerberized HDFS存储](tutorials/chapter-12.md)

* [架构设计]()
  * [整体设计](design/Design.md)
  * [段设计](design/segments.md)
  * [进程与服务](design/processes.md)
    * [Coordinator](design/Coordinator.md)
    * [Overlord](design/Overlord.md)
    * [Historical](design/Historical.md)
    * [MiddleManager](design/MiddleManager.md)
    * [Broker](design/Broker.md)
    * [Router](design/router.md)
    * [Indexer](design/Indexer.md)
    * [Peon](design/Peons.md)
  * [深度存储](design/Deepstorage.md)
  * [元数据存储](design/Metadata.md)
  * [Zookeeper](design/Zookeeper.md)

* [数据摄取]()
  * [摄取概述](ingestion/ingestion.md)
  * [数据格式](ingestion/dataformats.md)
  * [schema设计](ingestion/schemadesign.md)
  * [数据管理](ingestion/data-management.md)
  * [流式摄取](ingestion/kafka.md)
    * [Apache Kafka](ingestion/kafka.md)
    * [Apache Kinesis](ingestion/kinesis.md)
    * [Tranquility](ingestion/tranquility.md)
  * [批量摄取](ingestion/native.md)
    * [本地批](ingestion/native.md)
    * [Hadoop批](ingestion/hadoop.md)
  * [任务参考](ingestion/taskrefer.md)
  * [问题FAQ](ingestion/faq.md)

* [数据查询]()
  * [Druid SQL](querying/druidsql.md)
  * [原生查询](querying/makeNativeQueries.md)
  * [查询执行](querying/queryexecution.md)
  * [一些概念](querying/datasource.md)
    * [数据源](querying/datasource.md)
    * [Joins](querying/joins.md)
    * [Lookups](querying/lookups.md)
    * [多值维度](querying/multi-value-dimensions.md)
    * [多租户](querying/multitenancy.md)
    * [查询缓存](querying/querycached.md)
    * [上下文参数](querying/query-context.md)
  * [原生查询类型](querying/timeseriesquery.md)
    * [Timeseries](querying/timeseriesquery.md)
    * [TopN](querying/topn.md)
    * [GroupBy](querying/groupby.md)
    * [Scan](querying/scan.md)
    * [Search](querying/searchquery.md)
    * [TimeBoundary](querying/timeboundaryquery.md)
    * [SegmentMetadata](querying/segmentMetadata.md)
    * [DatasourceMetadata](querying/datasourcemetadataquery.md)
  * [原生查询组件](querying/filters.md)
    * [过滤](querying/filters.md)
    * [粒度](querying/granularity.md)
    * [维度](querying/dimensionspec.md)
    * [聚合](querying/aggregations.md)
    * [后聚合](querying/postaggregation.md)
    * [表达式](querying/expression.md)
    * [Having(GroupBy)](querying/having.md)
    * [排序和Limit(GroupBy)](querying/limitspec.md)
    * [排序(TopN)](querying/topnsorting.md)
    * [字符串比较器(String Comparators)](querying/sorting-orders.md)
    * [虚拟列(Virtual Columns)](querying/virtual-columns.md)
    * [空间过滤器(Spatial Filter)](querying/spatialfilter.md)

* [配置列表]()
  * [配置列表](configuration/human-readable-byte.md)

* [操作指南]()
  * [操作指南](operations/index.md)

* [开发指南]()
  * [开发指南](development/index.md)

* [其他相关]()
  * [其他相关](misc/index.md)

* [站内链接合集]()
  * [产品架构师进阶](book/1.md)
  * [ES源码解读](book/2.md)